#include <stdio.h>
#include <ctype.h>

//char *nextWord(char *text) {
//    if (text == NULL) {
//        return NULL;
//    }
//
//    while (*text != 0) {
//        if(isalpha(*text)) {
//            return text;
//        } // else {
//        text++;
//    // }
//    }
//
//    return NULL;
//}

//char *nextWord(char *text) {
//    static char *prevWord = NULL;
//
//    if (text == NULL) {
//        if (prevWord == NULL) {
//            return NULL;
//        }
//
//        text = prevWord;
//
//        while (*text != 0) {
//            if(!isalpha(*text)) {
//                break;
//            } // else {
//            text++;
//            // }
//        }
//
//    }
//
//    while (*text != 0) {
//        if(isalpha(*text)) {
//            prevWord = text;
//            return prevWord;
//        } // else {
//        text++;
//        // }
//    }
//
//    prevWord = NULL;
//    return prevWord;
//}

char *nextWord(char *text, int *L) {
    static char *prevWord = NULL;				// Μεταβλητή ώστε να "θυμάμαι" που είχα μείνει μέσα στο κείμενο (που ξεκινούσε η προηγούμενη λέξη που είχε βρεθεί)

    if (text == NULL) {							// Εάν δεν έχει δοθεί κείμενο (δηλαδή θα πρέπει να συνεχίσω από εκεί που είχα μείνει)
        if (prevWord == NULL) {					// Ελέγχω εάν είχα κρατήσει το που είχε βρεθεί η προηγούμενη λέξη.
//            if (L!=NULL) {					// Δεν χρειάζεται να θέσω το μήκος μηδενικό αφού επιστρέφω την τιμή NULL στον pointer που λέει ότι δεν βρήκα λέξη
//                *L = 0;
//            }
            return NULL;						// Επιστρέφω ότι δεν βρέθηκε λέξη. Θα μπορούσα για συνέπεια με τα υπόλοιπα return να επιστρέφω το prevWord (που είναι NULL, άρα κανει το ίδιο)
        }

        text = prevWord;						// Αλλιώς συνεχίζω το text από εκεί που είχε μείνει η προηγούμενη λέξη

		// Άρα θα πρέπει να φτάσω μετά το τέλος της ώστε να ξεκινήσω την αναζήτηση για την επόμενη λέξη
        while (*text != 0) {					// Όσο δεν έχω φτάσει στο τέλος του κειμένου
            if(!isalpha(*text)) {				// Εάν ο χαρακτήρας ΔΕΝ είναι αλφαβητικός
                break;							// Τότε τερματίζω την αναζήτηση
            } // else {
            text++;								// Αλλιώς - αφού συνεχίζω την αναζήτηση - προχωρώ για δοκιμή στον επόμενο χαρακτήρα
            // }
        }

    }

    while (*text != 0) {						// Τώρα πρέπει να βρώ την αρχή της λέξης
        if(isalpha(*text)) {					// Αν ο χαρακτήρας ΕΙΝΑΙ αλφαβητικός (=βρήκα την αρχή της λέξης)
            prevWord = text;					// Κρατάω που βρέθηκε η λέξη

            if (L != NULL) {					// Εάν μου έχει δοθέι μή NULL pointer, θα πρέπει να υπολογίσω το μήκος της λέξης
                (*L) = 0;						// Αρχικά υποθέτω ότι είναι μηδενικό (δεν ισχύει, το ξέρω, αλλά μετράω πάνω σε αυτό κάθε χαρακτήρα που δίνεται)
                while (isalpha(*text)) {		// Αν ΕΙΝΑΙ αλφαβητικός ( αυτό δεν ισχύει στο τέλος του κειμένου, καθώςο κωδικός 0 δεν είναι αλφαβητικός χαρακτήρας )
                    *text++;					// Αύξησε κατά ένα τον μετρητή χαρακτήρων
                    (*L)++;						// και προχωρώ στον επόμενο χαρακτήρα
                }
            }

            return prevWord;					// Επιστρέφω το σημείο που είχα βρεί την αρχή της λέξης
        } // else {
        text++;									// Προχωρώ στον επομενο χαρακτήρα. Το else δεν χρειάζεται (αν μπει δεν πειράζει) αφού ο κώδικας μέσα στο if κάνει return άρα δεν προχωρά μετά το if η εκτέλεση όταν η συνθήκη του, είναι αληθής.
        // }
    }

//    if (L!=NULL) {							// Και πάλι δεν χρειάζεται να θέσω το μήκος μηδενικό αφού επιστρέφω την τιμή NULL στον pointer που λέει ότι δεν βρήκα λέξη
//        *L = 0;
//    }
    prevWord = NULL;							// Κρατάω ότι ΔΕΝ βρέθηκε η λέξη
    return prevWord;							// Επιστρέφω το αποτέλεσμα
}


int main() {

    char *myText = " Na ena keimeno!";
    int len;

    printf("%s\n", myText);
    printf("Epomenh le3h (%d) : %s\n", len, nextWord(myText, &len));
    printf("Epomenh le3h (%d): %s\n", len, nextWord(NULL, &len));
    printf("Epomenh le3h (%d): %s\n", len, nextWord(NULL, &len));
    printf("Epomenh le3h (%d): %s\n", len, nextWord(NULL, &len));
    printf("Epomenh le3h (%d): %s\n", len, nextWord(NULL, &len));
    printf("Epomenh le3h (%d): %s\n", len, nextWord(NULL, &len));
    printf("Epomenh le3h (%d): %s\n", len, nextWord(NULL, &len));
    printf("Epomenh le3h (%d): %s\n", len, nextWord(NULL, &len));

    return 0;
}
